Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.ui.part
Class WorkbenchPart

    java.lang.Object
      org.eclipse.ui.part.WorkbenchPart

All Implemented Interfaces:
  IAdaptable, IExecutableExtension, IWorkbenchPart, IWorkbenchPart2

Direct Known Subclasses:
  EditorPart, ViewPart

public abstract class WorkbenchPart
extends Object
implements IWorkbenchPart2, IExecutableExtension

Abstract base implementation of all workbench parts.

This class is not intended to be subclassed by clients outside this package; clients should instead subclass `ViewPart` or `EditorPart`.

See Also:
  `ViewPart`, `EditorPart`

Field Summary

Fields inherited from interface org.eclipse.ui.IWorkbenchPart
`PROP_TITLE`

Constructor Summary
`protected` | `WorkbenchPart()` Creates a new workbench part.

Method Summary
`void` | `addPropertyListener(IPropertyListener l)` Adds a listener for changes to properties of this workbench part.
`abstract void` | `createPartControl(Composite parent)` Creates the SWT controls for this workbench part.
`void` | `dispose()` The `WorkbenchPart` implementation of this `IWorkbenchPart` method disposes the title image loaded by `setInitializationData`.
`protected void` | `firePropertyChange(int propertyId)` Fires a property changed event.
`Object` | `getAdapter(Class adapter)` Returns an object which is an instance of the given class associated with this object. Returns `null` if no such object can be found. Subclasses may override this method (however, if they do so, they should invoke the method on their superclass to ensure that the Platform's adapter manager is consulted).
`protected IConfigurationElement` | `getConfigurationElement()` Returns the configuration element for this part.
`String` | `getContentDescription()` Returns the content description of this part. The content description is an optional user-readable string that describes what is currently being displayed in the part. By default, the workbench will display the content description in a line near the top of the view or editor. An empty string indicates no content description text. If this value changes the part must fire a property listener event with `IWorkbenchPartConstants.PROP_CONTENT_DESCRIPTION`. It is considered bad practise to overload or extend this method.
`protected Image` | `getDefaultImage()` Returns the default title image.
`String` | `getPartName()` Returns the name of this part. If this value changes the part must fire a property listener event with `IWorkbenchPartConstants.PROP_PART_NAME`. It is considered bad practise to overload or extend this method.
`IWorkbenchPartSite` | `getSite()` Returns the site for this workbench part.
`String` | `getTitle()` Returns the title of this workbench part. If this value changes the part must fire a property listener event with `PROP_TITLE`. The title is used to populate the title bar of this part's visual container. It is considered bad practise to overload or extend this method.
`Image` | `getTitleImage()` Returns the title image of this workbench part.
`String` | `getTitleToolTip()` Returns the title tool tip text of this workbench part.
`void` | `removePropertyListener(IPropertyListener l)` Removes the given property listener from this workbench part.
`protected void` | `setContentDescription(String description)` Sets the content description for this part.
`abstract void` | `setFocus()` Asks this part to take focus within the workbench.
`void` | `setInitializationData(IConfigurationElement cfig, String propertyName, Object data)` This method is called by the implementation of the method `IConfigurationElement.createExecutableExtension` on a newly constructed extension, passing it its relevant configuration information. Most executable extensions only make use of the first two call arguments. Regular executable extensions specify their Java implementation class name as an attribute of the configuration element for the extension. For example
         <action run="com.example.BaseAction"/>
In the above example, this method would be called with a reference to the `<action>` element (first argument), and `"run"` as the name of the attribute that defined this executable extension (second argument). The last parameter is for the specific use of extension adapters and is typically not used by regular executable extensions. There are two supported ways of associating additional adapter-specific data with the configuration in a way that is transparent to the extension point implementor: (1) by specifying adapter data as part of the implementation class attribute value. The Java class name can be followed by a ":" separator, followed by any adapter data in string form. For example, if the extension point specifies an attribute `"run"` to contain the name of the extension implementation, an adapter can be configured as
         <action run="com.example.ExternalAdapter:./cmds/util.exe -opt 3"/>
(2) by converting the attribute used to specify the executable extension to a child element of the original configuration element, and specifying the adapter data in the form of xml markup. Using this form, the example above would become
         <action>
             <run class="com.xyz.ExternalAdapter">
                 <parameter name="exec" value="./cmds/util.exe"/>
                 <parameter name="opt"  value="3"/>
             </run>
         </action>
Form (2) will typically only be used for extension points that anticipate the majority of extensions configured into it will in fact be in the form of adapters. In either case, the specified adapter class is instantiated using its 0-argument public constructor. The adapter data is passed as the last argument of this method. The data argument is defined as Object. It can have the following values: `null`, if no adapter data was supplied in case (1), the initialization data string is passed as a `String` in case (2), the initialization data is passed as a `Hashtable` containing the actual parameter names and values (both `String`s) The `WorkbenchPart` implementation of this `IExecutableExtension` records the configuration element in and internal state variable (accessible via `getConfigElement`).
`protected void` | `setPartName(String partName)` Sets the name of this part.
`protected void` | `setSite(IWorkbenchPartSite site)` Sets the part site.
`protected void` | `setTitle(String title)` Deprecated. new code should use setPartName and setContentDescription
`protected void` | `setTitleImage(Image titleImage)` Sets or clears the title image of this part.
`protected void` | `setTitleToolTip(String toolTip)` Sets or clears the title tool tip text of this part.
`void` | `showBusy(boolean busy)` Show that this part is busy due to a Job running that it is listening to.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### WorkbenchPart

    protected WorkbenchPart()

  Creates a new workbench part.

Method Detail

### addPropertyListener

    public void addPropertyListener(IPropertyListener l)

  Description copied from interface: `IWorkbenchPart`
  Adds a listener for changes to properties of this workbench part. Has no effect if an identical listener is already registered.

  The property ids are defined in `IWorkbenchPartConstants`.

  Specified by:
    `addPropertyListener` in interface `IWorkbenchPart`
  Parameters:
    `l` - a property listener

### createPartControl

    public abstract void createPartControl(Composite parent)

  Description copied from interface: `IWorkbenchPart`
  Creates the SWT controls for this workbench part.

  Clients should not call this method (the workbench calls this method when it needs to, which may be never).

  For implementors this is a multi-step process:

  1. Create one or more controls within the parent.
  2. Set the parent layout as needed.
  3. Register any global actions with the `IActionService`.
  4. Register any popup menus with the `IActionService`.
  5. Register a selection provider with the `ISelectionService` (optional).

  Specified by:
    `createPartControl` in interface `IWorkbenchPart`
  Parameters:
    `parent` - the parent control

### dispose

    public void dispose()

  The `WorkbenchPart` implementation of this `IWorkbenchPart` method disposes the title image loaded by `setInitializationData`. Subclasses may extend.

  Specified by:
    `dispose` in interface `IWorkbenchPart`

### firePropertyChange

    protected void firePropertyChange(int propertyId)

  Fires a property changed event.

  Parameters:
    `propertyId` - the id of the property that changed

### getAdapter

    public Object getAdapter(Class adapter)

  Returns an object which is an instance of the given class associated with this object. Returns `null` if no such object can be found. Subclasses may override this method (however, if they do so, they should invoke the method on their superclass to ensure that the Platform's adapter manager is consulted).

  Specified by:
    `getAdapter` in interface `IAdaptable`
  Parameters:
    `adapter` - the adapter class to look up
  Returns:
    a object castable to the given class, or `null` if this object does not have an adapter for the given class

### getConfigurationElement

    protected IConfigurationElement getConfigurationElement()

  Returns the configuration element for this part. The configuration element comes from the plug-in registry entry for the extension defining this part.

  Returns:
    the configuration element for this part

### getDefaultImage

    protected Image getDefaultImage()

  Returns the default title image.

  Returns:
    the default image

### getSite

    public IWorkbenchPartSite getSite()

  Description copied from interface: `IWorkbenchPart`
  Returns the site for this workbench part. The site can be `null` while the workbench part is being initialized. After the initialization is complete, this value must be non-`null` for the remainder of the part's life cycle.

  Specified by:
    `getSite` in interface `IWorkbenchPart`
  Returns:
    The part site; this value may be `null` if the part has not yet been initialized

### getTitle

    public String getTitle()

  Returns the title of this workbench part. If this value changes the part must fire a property listener event with `PROP_TITLE`.

  The title is used to populate the title bar of this part's visual container.

  It is considered bad practise to overload or extend this method. Parts should set their title by calling setPartName and/or setContentDescription.

  Specified by:
    `getTitle` in interface `IWorkbenchPart`
  Returns:
    the workbench part title (not `null`)

### getTitleImage

    public Image getTitleImage()

  Description copied from interface: `IWorkbenchPart`
  Returns the title image of this workbench part. If this value changes the part must fire a property listener event with `PROP_TITLE`.

  The title image is usually used to populate the title bar of this part's visual container. Since this image is managed by the part itself, callers must not dispose the returned image.

  Specified by:
    `getTitleImage` in interface `IWorkbenchPart`
  Returns:
    the title image

### getTitleToolTip

    public String getTitleToolTip()

  Description copied from interface: `IWorkbenchPart`
  Returns the title tool tip text of this workbench part. An empty string result indicates no tool tip. If this value changes the part must fire a property listener event with `PROP_TITLE`.

  The tool tip text is used to populate the title bar of this part's visual container.

  Specified by:
    `getTitleToolTip` in interface `IWorkbenchPart`
  Returns:
    the workbench part title tool tip (not `null`)

### removePropertyListener

    public void removePropertyListener(IPropertyListener l)

  Description copied from interface: `IWorkbenchPart`
  Removes the given property listener from this workbench part. Has no affect if an identical listener is not registered.

  Specified by:
    `removePropertyListener` in interface `IWorkbenchPart`
  Parameters:
    `l` - a property listener

### setFocus

    public abstract void setFocus()

  Description copied from interface: `IWorkbenchPart`
  Asks this part to take focus within the workbench.

  Clients should not call this method (the workbench calls this method at appropriate times). To have the workbench activate a part, use `IWorkbenchPage.activate(IWorkbenchPart) instead`.

  Specified by:
    `setFocus` in interface `IWorkbenchPart`

### setInitializationData

    public void setInitializationData(IConfigurationElement cfig,
                                      String propertyName,
                                      Object data)

  This method is called by the implementation of the method `IConfigurationElement.createExecutableExtension` on a newly constructed extension, passing it its relevant configuration information. Most executable extensions only make use of the first two call arguments.

  Regular executable extensions specify their Java implementation class name as an attribute of the configuration element for the extension. For example

           <action run="com.example.BaseAction"/>

  In the above example, this method would be called with a reference to the `<action>` element (first argument), and `"run"` as the name of the attribute that defined this executable extension (second argument).

  The last parameter is for the specific use of extension adapters and is typically not used by regular executable extensions.

  There are two supported ways of associating additional adapter-specific data with the configuration in a way that is transparent to the extension point implementor:

  (1) by specifying adapter data as part of the implementation class attribute value. The Java class name can be followed by a ":" separator, followed by any adapter data in string form. For example, if the extension point specifies an attribute `"run"` to contain the name of the extension implementation, an adapter can be configured as

           <action run="com.example.ExternalAdapter:./cmds/util.exe -opt 3"/>

  (2) by converting the attribute used to specify the executable extension to a child element of the original configuration element, and specifying the adapter data in the form of xml markup. Using this form, the example above would become

           <action>
               <run class="com.xyz.ExternalAdapter">
                   <parameter name="exec" value="./cmds/util.exe"/>
                   <parameter name="opt"  value="3"/>
               </run>
           </action>

  Form (2) will typically only be used for extension points that anticipate the majority of extensions configured into it will in fact be in the form of adapters.

  In either case, the specified adapter class is instantiated using its 0-argument public constructor. The adapter data is passed as the last argument of this method. The data argument is defined as Object. It can have the following values:

  - `null`, if no adapter data was supplied
  - in case (1), the initialization data string is passed as a `String`
  - in case (2), the initialization data is passed as a `Hashtable` containing the actual parameter names and values (both `String`s)
  The `WorkbenchPart` implementation of this `IExecutableExtension` records the configuration element in and internal state variable (accessible via `getConfigElement`). It also loads the title image, if one is specified in the configuration element. Subclasses may extend. Should not be called by clients. It is called by the core plugin when creating this executable extension.

  Specified by:
    `setInitializationData` in interface `IExecutableExtension`
  Parameters:
    `cfig` - the configuration element used to trigger this execution. It can be queried by the executable extension for specific configuration properties
    `propertyName` - the name of an attribute of the configuration element used on the `createExecutableExtension(String)` call. This argument can be used in the cases where a single configuration element is used to define multiple executable extensions.
    `data` - adapter data in the form of a `String`, a `Hashtable`, or `null`.
  See Also:
    `IConfigurationElement.createExecutableExtension(String)`

### setSite

    protected void setSite(IWorkbenchPartSite site)

  Sets the part site.

  Subclasses must invoke this method from `IEditorPart.init` and `IViewPart.init`.

  Parameters:
    `site` - the workbench part site

### setTitle

    protected void setTitle(String title)

  Deprecated. new code should use setPartName and setContentDescription

  Sets or clears the title of this part. Clients should call this method instead of overriding getTitle.

  This may change a title that was previously set using setPartName or setContentDescription.

  Parameters:
    `title` - the title, or `null` to clear

### setTitleImage

    protected void setTitleImage(Image titleImage)

  Sets or clears the title image of this part.

  Parameters:
    `titleImage` - the title image, or `null` to clear

### setTitleToolTip

    protected void setTitleToolTip(String toolTip)

  Sets or clears the title tool tip text of this part. Clients should call this method instead of overriding `getTitleToolTip`

  Parameters:
    `toolTip` - the new tool tip text, or `null` to clear

### showBusy

    public void showBusy(boolean busy)

  Show that this part is busy due to a Job running that it is listening to.

  Parameters:
    `busy` - boolean to indicate that the busy state has started or ended.
  Since:
    3.0
  See Also:
    `IWorkbenchSiteProgressService.showBusyForFamily(Object)`

### getPartName

    public String getPartName()

  Returns the name of this part. If this value changes the part must fire a property listener event with `IWorkbenchPartConstants.PROP_PART_NAME`.

  It is considered bad practise to overload or extend this method. Parts should call setPartName to change their part name.

  Specified by:
    `getPartName` in interface `IWorkbenchPart2`
  Returns:
    the name of this view, or the empty string if the name is being managed by the workbench (not `null`)

### setPartName

    protected void setPartName(String partName)

  Sets the name of this part. The name will be shown in the tab area for the part. Clients should call this method instead of overriding getPartName. Setting this to the empty string will cause a default part name to be used.

  setPartName and setContentDescription are intended to replace setTitle. This may change a value that was previously set using setTitle.

  Parameters:
    `partName` - the part name, as it should be displayed in tabs.
  Since:
    3.0

### getContentDescription

    public String getContentDescription()

  Returns the content description of this part. The content description is an optional user-readable string that describes what is currently being displayed in the part. By default, the workbench will display the content description in a line near the top of the view or editor. An empty string indicates no content description text. If this value changes the part must fire a property listener event with `IWorkbenchPartConstants.PROP_CONTENT_DESCRIPTION`.

  It is considered bad practise to overload or extend this method. Parts should call setContentDescription to change their content description.

  Specified by:
    `getContentDescription` in interface `IWorkbenchPart2`
  Returns:
    the content description of this part (not `null`)

### setContentDescription

    protected void setContentDescription(String description)

  Sets the content description for this part. The content description is typically a short string describing the current contents of the part. Setting this to the empty string will cause a default content description to be used. Clients should call this method instead of overriding getContentDescription(). For views, the content description is shown (by default) in a line near the top of the view. For editors, the content description is shown beside the part name when showing a list of editors. If the editor is open on a file, this typically contains the path to the input file, without the filename or trailing slash.

  This may overwrite a value that was previously set in setTitle

  Parameters:
    `description` - the content description
  Since:
    3.0

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Guidelines for using Eclipse APIs.

Copyright (c) IBM Corp. and others 2000, 2004. All rights reserved.